# Job service

This service is a process bean that provides a way to manipulate jobs within the current process.

### Changing Timer event date

Job service currently provides two methods that allow for an update on the timer due date in the current process.

```kotlin
updateTimerDueDateByActivityId("2300-01-01T00:00:00Z","timer-id",execution)
addOffsetInMillisToTimerDueDateByActivityId(1000,"timer-id",execution)
```

* "updateTimerDueDateByActivityId" - allows changing the date by passing it as "String", in the ISO 8601 format , as the first parameter along with the timer event id and the current execution of the process as second and third parameters respectively.
* "addOffsetInMillisToTimerDueDateByActivityId" - used to add an offset to the current set due date by providing the amount to be added(in milliseconds) by passing a positive number, or subtracted with a negative number.

**How to use**

In this example a timer exists with the given id "timer-test"

![timer](/files/0TLQEcdyr5xEworRHVC8)

Somewhere else in the process a sub-process exists with a service task where the job service is called in an expression with a negative number in order to move forward a job in time as show below

![job-service-example](/files/5q3WFjP9Dha40twMcZwE)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.valtimo.nl/v12/features/process/job-service.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
